package xyz.etztech.serverapi.web.api;

import com.expediagroup.graphql.annotations.GraphQLDescription;
import com.expediagroup.graphql.annotations.GraphQLName;
import org.bukkit.OfflinePlayer;

@GraphQLName("Player")
@GraphQLDescription("Player GraphQL")
public class PlayerAPI {
    private final String name;
    private final String uuid;

    public PlayerAPI(String name, String uuid) {
        this.name = name;
        this.uuid = uuid;
    }

    @GraphQLName("name")
    public String getName() {
        return name;
    }

    @GraphQLName("uuid")
    public String getUUID() {
        return uuid;
    }

    public static PlayerAPI fromMinecraft(OfflinePlayer player) {
        return new PlayerAPI(player.getName(), player.getUniqueId().toString());
    }
}
